
#define Version "190717"
// modif delay envoi data : toutes les 2 sec au lieu de 1,2sec
// passage en FU4 au lieu de FU3
// 1200bds RC005  P8 (+20dBm)

//#define Version "190716"
// passage  1200 bds
// pour faire un test similaire  celui de PSPIC
// idem Dist max<30M
// delai envoi data 1,2sec
// FU3   1200bds  RP=+20dBm  RC005

//#define Version "190715"
// rajout commande choix puissance  distance PU=x  avec  x de 1  8   => commande AT+P1  AT+P8
// porte maxi 25M  travers 2 murs et 1 cloison
// PIC12F1840 Dip8 + HC12
// envoi chaque sec  valeur de l'indice 0  65535 + mesures capteur DS18B20
// si reception par HC12 distant , analyse la commande recue et reagit
// ex de cde distance LED=1 ou LED=2 , concerne la led sur RA0 du PIC12F
// mode P8 maxi activ  et FU04 1200 bauds
// conso moyenne 25mA
// et 11mA en mode AT ( pin SET du HC08 au 0V)
// revient  25mA en laissant SET  1 ( en l'air , pullup interne
// MCU presque FULL en RAM !!!!!!!!!!!!!!!!!!!!!!!!!
//  Used RAM (bytes): 237 (99%)  Free RAM (bytes): 3 (1%)
// Used ROM (program words): 2269 (55%)  Free ROM (program words): 1827 (45%)
// 9600 bauds maxi avec HC12   en mode FU3
// 1200 bauds en mode FU4

/*
21/07/2012
Led rouge sur RA0  OK apres reinit de TRISA APRES l'init UART

20/07/2012    Test OK on UART and timer1 , but nor problem with RA0 output never change
correction bug sur ifdef interupt -> normal was ifdef interrupt ( with 2 r)
adding error treatment inside the UART ISR   clear SPEN !
removing polling mode , now not usefull...

14/07/2012
Pickit2 OK avec  PIC12F1840, il faut choisir la famille 1,8V !!
mode pooling OK , meme avec une trame de 32 caracteres
mode interrupt UART NOT OK .. pas d'appel interruption !!!
mode Timer1 interrupt OK
Impossible non plus de commander la sortie RA2

last update: 22/04/2012
PB avec Pickit2 ??  malgre MAJ firmware et file data
le 12F1840   n'est pas reconnu...

 * Projet : 12F1840_Usart_RA4_RA5_Interrupt_Timer1.mcppi
   SW:  mikroC PRO for PIC   V 5.61
   test fonction uart
   MCU : PIC12F1840  ehanced type
   Directory : C:\_MickroC\_MesProjets_MickroC\_12F1840
   Source : 12F1840_Usart_RA4_RA5_Interrupt_Timer1.c
   Programmateur tools : PicKit2  (choose 1,8V family!)
   config bits:
   CONFIG1   :$8007 : 0x0984
   CONFIG2   :$8008 : 0x3413
   config vu par Pickit2 :  0984 3413 <- OK
   nota : pas besoin de faire un export pour que l' Hex soit  jour !
          ce qui n'est pas le cas sous MPLAB !
   VDD    : 5,0V    ( from 2,3 to 5,5V)
   horloge  :  interne  16 MHz ... pas de quartz
   Librairies utilisees :
   - built_in.h
   - UART
   - C_String
   - Conversions
   - ADC
   
   pinout :   
   device ID =  01 1011 100
   Calibrations words 8009h & 800Ah
   hex file au format : INHX32   LSB puis MSB
   docu :
 */
        //
        //
        
  /* Hardware
  12F1840
  pin 1     VDD Alim +5V
  pin 2     RA5  input RX ---- <---- Pin 4  HC12 TX
  pin 3     RA4  output TX ---->---- Pin 3  HC12 TX
  pin 4     RA3/MCLR/VPP -- ICSP Reset
  pin 5     RA2  input <--- OWS DS18B20
  pin 6     RA1 ICSP Clock & Output -> Pin 5  SET HC12 input
  pin 7     RAO  ICSPDAT   & Output -> R2,7K-- Led-- 0V
  pin 8     VSS alim 0V
  */
  
   //ac:MCU_Pinout_
   
    //ac:Interrupts

#include "built_in.h"     // for  Hi  Lo ..etc
  
#define TAB 9
#define CLS 12
#define CR 13
#define LF 10

#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_HC12_Transceiver_433Mhz"
#define Projet "12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.mcppi"
#define Source "_12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20"      // sans date ni  extension !
#define Langage "MikroC 7.5.0"
#define Config "P12F1840_Fosc_Interne_16MHz.cfgsch"
//CONFIG1 : $8007 : 0x0984
//CONFIG2 : $8008 : 0x3413

#define MCU "12F1840 DIP8"
#define POWER_SUPPLY "3,6V  4.5V"    // (3,3 to 4,2V battery Li-IOn)
#define OSCILLATEUR_INTERNE
#define FOSC "16MHZ"
#define EEPROM_FILE "xxx_Eeprom.ihex"
#define Bauds "1200"

#define OWS_Pin  &PORTA,2
#define Led_Rouge LATA.F0      // RA0
#define SET_Pin  LATA.F1

const code char mesg0[]="                    "; // 20 blancs pour effacer la ligne LCD
const code char mesg1[]=" Compilateur : "Langage"\n\r";
const code char mesg2[]=" Directory :"Directory"\r\n";
const code char mesg3[]=" Projet    :"Projet"\r\n";
const code char mesg4[]=" Source    :"Source"_"Version"\r\n";
const code char mesg5[]=" MCU  :"MCU"  Config: "Config" \r\n";
const code char mesg6[]=" POWER_SUPPLY: "POWER_SUPPLY"\r\n Attention :Pin 1 =VDD pin 8=Gnd\r\n";
const code char mesg7[]=" Capteur OWS DS18B20 sur RA2\  Led sur RA0   pin SET sur RA1\r\n";
const code char mesg8[]=" HC08 FU4 mode \r\n UART1 "Bauds",8,N,1  pin2=RA5=RX  Pin3=RA4=Tx r\n";
//const code char mesg9[]=" Pin 7 RA0=Led Rouge r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8}; //,mesg9};

//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  18S20: 9  (default setting; can be 9,10,11,or 12)
//  18B20: 12
//const unsigned short TEMP_RESOLUTION = 12;
unsigned int temp=0;


//unsigned long  NbCycles=3035 ;       //65535-62500=3035 @16Mhz et prescaler=8 => 125mS
//test  avec valeur init Timer1  0000 => OK
// unsigned long  NbCycles=0 ; // @16Mhz    65535-0=65535  prescaler=1/1 => 15.625 mS
// Count0=61 pour 1 seconde  ou 122 pour 2 sec

 
unsigned short error;
volatile unsigned int CptErr;
volatile unsigned int Count;
volatile int Flag_Timer1;
volatile int Flag_Buffer1;
volatile int Index1, i1;
volatile  unsigned char c1, cx;
volatile int j;
unsigned int i,k;
//unsigned M;
char *p1;
char buffer1[81];
char *txt;
char Texte[81];//  ="12F1840_Usart_Interrupt_Timer1";

//unsigned long  DS18B20_Temp1=0L;
//unsigned char TH1,TL1,AL1;
//unsigned char ID1[6];


void strConstRamCpy(char *dest, const char *source);
void Write_String(char * texte);
void CRLF1(void);
void Tempo(unsigned long L);
void Init_Timer1(void);
char  DS18B20_Build_value(unsigned int temp2write)  ;



void Interrupts() iv 0x0004 ics ICS_AUTO 
{

 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       TXREG=c1;     // echo of receiveid char
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
      c1 = RCREG;
     if (c1==CR)
      {
      Flag_Buffer1=1;
      RCIE_bit=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
     PIR1.RCIF=0   ;
   }
 // timer 1
  if( (PIR1.TMR1IF==1) && ( TMR1IE_bit==1) )
  {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
      //  TMR1H= Hi (NbCycles);
      ////  TMR1L= Lo (NbCycles);
        TMR1H         = 0x3C;   // 100mS
        TMR1L         = 0xB0;
        Count++;
      if (Count>19)
       {
          Count=0;
          Flag_Timer1=1;
        //  Led_Rouge=!Led_Rouge;
        }
      PIR1.TMR1IF=0;
   }

 }

void Write_String(char * texte)
{
while (* texte)
 {
  UART_Write(* texte++);
 }
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source) {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART_Write(CR);
 UART_Write(LF);
}
void UART1_Write_CText(const char *txt) {
   while (*txt)
      UART1_Write(*txt++);
      Delay_ms(1);

}

void Raz_Buffer1()
{
      Flag_Buffer1 =0;
      // nettoye le buffer
      for(Index1=0;Index1<80-1;Index1++)  buffer1[Index1]=0;
      c1=RCREG;
      i1=0;
      Index1=0;
      c1=0;
      RCIE_bit = 1;
      p1=0;

}


void Init_Timer1(void)
{
  //Prescaler 1:8; TMR1 Preload = 15536; Actual Interrupt Time : 100 ms  at 16Mhz
  T1CON         = 0x30;

  //    TMR1H= Hi (NbCycles);
  //    TMR1L= Lo (NbCycles);
  //  TMR1H=0x0B; TMR1L=0xDB; // 65536-62500=3035
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
  TMR1IE_bit         = 1;
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  T1GCON=0;
  T1GCON.T1GTM=0;    // Timer1 gate mode disable
  Flag_Timer1=0;
  Count=0;
  PIE1.TMR1IE=1;  // Enable interrupt TMR1
  TMR1IF_bit         = 0;
  TMR1ON_bit=1;
  
}



char  DS18B20_Build_value(unsigned int temp2write)
 {
 int jj;
 const unsigned int RES_SHIFT =4;  //  economie de 1 byte  en supprimant  TEMP_RESOLUTION (- 8);
  unsigned char temp_whole;
  unsigned int temp_fraction;
  char Signe=0;
  // Check if temperature is negative
    // Check if temperature is negative
  if (temp2write & 0x8000) {
     Signe=1  ;
      TEXTE[0] = '-';
     temp2write = ~temp2write + 1;
     }
     else
     {
     Signe=0;
    TEXTE[0] = ' ';
     }
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  // Convert temp_whole to characters
  TEXTE[1] = (temp_whole/10)%10 + 48;             // Extract tens digit
  if (TEXTE[1]=='0')TEXTE[1]=' ';
  TEXTE[2] =  temp_whole%10     + 48;             // Extract ones digit
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;
   TEXTE[3]='.';
  // Convert temp_fraction to characters
  TEXTE[4] =  temp_fraction/1000    + 48;         // Extract thousands digit
  TEXTE[5] = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
  TEXTE[6] =0;// (temp_fraction/10)%10  + 48;         // Extract tens digit
  TEXTE[7]= 0; //temp_fraction%10      + 48;         // Extract ones digit
  TEXTE[8]=0;
  Ltrim(TEXTE+1);
 /*
 if (Signe==1)
  DS18B20_Temp1= ( temp_whole *1000) +temp_fraction  ;
  else
   DS18B20_Temp1= -(( temp_whole *1000) +temp_fraction  );
   */
   return Signe  ;
 }




void main()
{
   // voir page 61
  // 0=4xPLL OFF, 1111=IOFS=16Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  OSCCON=0b01111000;
      // RA5 as input for RX , RA4 as output for TX RA2 as input
  TRISA=0b0100100;      // RA0 et RA1 en sorties
  ANSELA=0;             // no analog

  WPUA=0b00110000;      // weak pull up on RX & TX

  CM1CON0=0;       // disable comparators
  CM1CON1=0;
   // RA4=TX RA5=RX   (voir page 111 )
  APFCON=0;
  APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
  APFCON.RXDTSEL=1;   // RX sur RA5
  APFCON.TXCKSEL=1;   // TX sur RA4
    // RA5 as input for RX , RA4 as output for TX RA2 as input
  TRISA=0b0100100;      // RA0,RA1 en sortie      RA2 en entree
  PORTA=0;

  FVRCON.FVREN=0;       //disable  voltage reference     (voir page 124)
  FVRCON.TSEN=0;        // temperature enable=0;
  FVRCON.CDAFVR1=0;     // Comparator & DAC OFF
  
    // RA5 input RX , RA4 output TX, RA2 = OWS input

   txt=&Texte[0];
   UART1_Init(1200);
   
   // re-init AGAIN , because Uart init disturbing
   TRISA=0b0100110;      // RA0  en sortie

   // 2 times to get empty fifo !
   if (PIR1.RCIF==1) c1 = RCREG;     // vide Fifo
   if (PIR1.RCIF==1) c1 = RCREG;     // vide fifo
   Flag_Buffer1=0;
   Index1=0;


/* test Ok      */
   UART1_Write_CText(" OSCSTAT = ");
   ByteToStr(OSCSTAT,txt);
   UART1_Write_Text(txt);
   UART1_Write(TAB);
   ByteToHex(OSCSTAT,txt);
   UART1_Write_Text(txt);
   CRLF1();
   if ((OSCSTAT.HFIOFL==1) && (OSCSTAT.HFIOFS==1))
   {
   UART1_Write_CText(" Osc stable ..OK \n\r");
   }
   CRLF1();

   // presentation
   for (i=1;i<9;i++)
   {
   UART1_Write_CText(Messages[i]);
   Delay_ms(100);
   }
   
   Count=0;
   CptErr=0;
   c1=0;
    //
    
     UART1_Write_CText(" Test registres DS18B20\r\n");
   Delay_ms(100);
     j=0;
     Ow_Reset(OWS_Pin);       // Onewire reset signal
      Delay_us(250);
     Ow_Write(OWS_Pin, 0x33); // Read ROM (if only one device)
      Delay_us(250);
     c1=Ow_Read(OWS_Pin); //  123456789012345678901234567890123456789012345678
        Delay_us(250);
     UART1_Write_CText(" Family Code : ");
      txt=&TEXTE[0];
      *(txt)=0;
     ByteToHex(c1,txt);
     UART1_Write_Text(txt);
     //Data: FamilyCo8 ID1= FF4715811603 CRC= 24
     UART1_Write_CText(" ID1= ");
     for (i=0;i<6;i++)
     {
     c1=  Ow_Read(OWS_Pin);
      Delay_us(250);
    // ID1[i]=c1;
     *(txt)=0;
     ByteToHex(c1,txt);
     UART1_Write_Text(txt);
     }
     UART1_Write_CText("  CRC= ");
     c1=  Ow_Read(OWS_Pin); // CRC
      *(txt)=0;
     ByteToHex(c1,txt);
     UART1_Write_Text(txt);
     CRLF1();

     Raz_Buffer1();
     PEIE_bit = 1;
     GIE_bit = 1;
     WUE_bit = 1;


  RCSTA=0;
  RCSTA.CREN=1;  //enable receiver
  RCSTA.SPEN=1;  // serial port Pins Enable
  RCSTA.SREN=1;  // single bit receive
  c1 = RCREG;   // RAZ errors

  OPTION_REG=0;  // concerne Timer0 et RA2 int
  PIE2=0;
  PIE1=0;

   UART1_Write_CText(" IT UART RA4-RA5 & Timer1\n\r");
   CRLF1();

   INTCON=0;
   Init_Timer1();   // config timer1
   T1CON.TMR1ON=1;  // lance timer1
   PIE1.TMR1IE=1;  // Enable interrupt on PR1=TMR1
   PIE1.RCIE=1 ; // autorise IT Reception UART
   INTCON.PEIE=1;  // autorise IT des peripherique voir fig  8.1 p 77
   INTCON.GIE=1;   // Enable all interrupts (timer1 & UART)

  j=0;
  k=0;
  Raz_Buffer1();
  SET_Pin=1;
  Delay_ms(100);
  
  while(1)
  {
   j++;
   Init_Timer1();
   Raz_Buffer1();
         Ow_Reset(OWS_Pin);              // Onewire reset signal
         Ow_Write(OWS_Pin, 0xCC);       // Issue command SKIP_ROM
         Ow_Write(OWS_Pin, 0x44);       // Issue command CONVERT_T
         Delay_us(250);
         Ow_Reset(OWS_Pin);
         Ow_Write(OWS_Pin, 0xCC);                   // Issue command SKIP_ROM
         Ow_Write(OWS_Pin, 0xBE);                   // Issue command READ_SCRATCHPAD    for only one sensor
         //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temperature register
         temp =  Ow_Read(OWS_Pin);
         temp = (Ow_Read(OWS_Pin) << 8) + temp;
          //  Bytes 2 and 3 provide access to TH and TL registers
          // After the DS18B20 performs a temperature conversion, the temperature value is compared
          // to the user-defined twos complement alarm trigger values stored
          //  in the 1-byte TH and TL registers (see Figure 3).
          // The sign bit (S) indicates if the value is positive or negative:
          // for positive numbers S = 0 and for negative numbers S = 1.
          //  The TH and TL registers are nonvolatile (EEPROM) so they will retain data when the
          // device is powered down. TH and TL can be accessed through bytes 2 and 3 of the
          //  scratchpad as explained in the Memory section
         //TH1=
         cx= Ow_Read(OWS_Pin);
         //TL1=
         cx=  Ow_Read(OWS_Pin);
          //--- Format and display result
          txt=&TEXTE[0];
          WordToStr(j,txt);  UART1_Write_Text(txt);
           UART1_Write_CText("  DS#1= ");
          cx= DS18B20_Build_value(temp) ;
           UART1_Write_Text(txt);
           CRLF1();
    Delay_ms(500);
  // wait end of timer 1 Tempo 1 sec
    while ((Flag_Timer1==0) && (Flag_Buffer1==0));
    Flag_Timer1=0;
    
    //  Wait to flag buffer full or string ended by car=CR=13)0x0D
//  Uart with interrupt
   if( Flag_Buffer1==1)
    {
     // renvoi la commande  l'emetteur
     CRLF1();UART_Write_Text(buffer1); CRLF1();

     p1=buffer1;
     if ( (*(p1)=='L') && (*(p1+1)=='E') && (*(p1+2)=='D') && (*(p1+3)=='='))
     {
        if (*(p1+4)=='1') Led_Rouge=1; else Led_Rouge=0;
        p1=0;
      }
      if ( (*(p1)=='P') && (*(p1+1)=='U')&& (*(p1+2)=='='))
      {  cx=*(p1+3);
        if ((cx>'0') && (cx<'9'))
        {
         UART1_Write_CText("\r\n Modif Puissance Emetteur distant\r\n");
         SET_Pin=0;
         Delay_ms(500);
         UART1_Write_CText("AT+P");  UART1_Write(cx);CRLF1();
         Delay_ms(500);
         SET_Pin=1;
         Delay_ms(500);
         }
         else
          UART1_Write_CText("\r\nErrare !\r\n");
         cx=0;
         p1=0;
      }
      
     c1=0;
     Index1=0;
     CptErr=0;
      Flag_Buffer1=0;
    }
  } // while (1)
 }

/*

HC12 #02 pastille Bleue cot Recepteur Terminal PC Terterm
AT
OK
AT+B1200
AT+RX
OK+B1200
OK+RC005
OK+RP:+20dBm
OK+FU3

idem sur Emetteur PIC12F1840 distant + HC12 #01 Pastille Jaune
AT
OK
AT+B1200
OK+B1200
AT+RX
OK+B1200
OK+RC005
OK+RP:+20dBm
OK+FU3

 Osc stable ..OK

 Compilateur : MikroC 7.5.0
 Directory :C:\_MikroC\_MesProjets_MikroC\_HC12_Transceiver_433Mhz
 Projet    :12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.mcppi
 Source    :_12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20_190716
 MCU  :12F1840 DIP8  Config: P12F1840_Fosc_Interne_16MHz.cfgsch
 POWER_SUPPLY: 3,3V
 Attention :Pin 1 =VDD pin 8=Gnd
 Capteur OWS DS18B20 sur RA2  Led sur RA0   pin SET sur RA1
 HC08 FU4 mode
 UART1 1200,8,N,1  pin2=RA5=RX  Pin3=RA4=Tx r
 Test registres DS18B20
 Family Code : 28 ID1= FF4715811603  CRC= 24
 IT UART RA4-RA5 & Timer1

    1  DS#1=  85.00
    2  DS#1=  28.18
    3  DS#1=  28.18

  
  cot recepteur !
  
    1  DS#1=  26.00
    2  DS#1=  25.93
    3  DS#1=  25.93
    4  DS#1=  26.00
  ... etc ..
   93  DS#1=  26.62
   94  DS#1=  26.62
PU=2

 Modif Puissance Emetteur distant
AT+P2
   75  DS#1=  26.93
   76  DS#1=  26.93
   77  DS#1=  26.93
   78  DS#1=  26.93
   79  DS#1=  26.93
   80  DS#1=  26.93
   81  DS#1=  26.93
   82  DS#1=  26.93
   83  DS#1=  26.93
   84  DS#1=  26.93

LED=1
   85  DS#1=  26.93
   86  DS#1=  26.93
   87  DS#1=  26.93
   88  DS#1=  26.93
   89  DS#1=  26.93
   90  DS#1=  26.93
   91  DS#1=  26.93
   92  DS#1=  26.93

LED=0
   93  DS#1=  26.93
   94  DS#1=  26.93
 
**************************************************
0 1 mikroCPIC1618.exe -MSF -DBG -pP12F1840 -DL -O11111114 -fo16 -N"^C
C:\_MikroC\_MesProjets_MikroC\_12F1840\12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_12F1840\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" "_12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CString.mcl" "
_Lib_Conversions.mcl" "
_Lib_OneWire.mcl" "
_Lib_ADC_B.mcl" "
_Lib_UART_a01.mcl"
0 1139 Available RAM: 240 [bytes], Available ROM: 4096 [bytes]
0 122 Compilation Started _12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.c
0 1004 interrupt handler (Interrupts at 0x0004) _12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.c
271 1163 Variable 'jj' has been declared, but not used _12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.c
347 1509 Generated baud rate is 19231 bps (error = 0.16 percent) _12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.c
503 123 Compiled Successfully _12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.c
0 127 All files Compiled in 266 ms
0 1144 Used RAM (bytes): 237 (99%)  Free RAM (bytes): 3 (1%) Used RAM (bytes): 237 (99%)  Free RAM (bytes): 3 (1%)
0 1144 Used ROM (program words): 2243 (55%)  Free ROM (program words): 1853 (45%) Used ROM (program words): 2243 (55%)  Free ROM (program words): 1853 (45%)
0 125 Project Linked Successfully 12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.mcppi
0 128 Linked in 156 ms
0 129 Project '12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.mcppi' completed: 500 ms
0 103 Finished successfully: 14 juil. 2019, 11:18:33 12F1840_UART_RA4_RA5_IT_Timer1_HC12_DS18B20.mcppi


*/